import { JSONSchema } from '@aws-amplify/graphql-transformer-core';
import { TransformerContextProvider } from '@aws-amplify/graphql-transformer-interfaces';
import { CustomQueryTool, ModelOperationTool, ToolDefinition } from '../conversation-directive-configuration';
export type Tool = {
    name: string;
    description: string;
    inputSchema: {
        json: JSONSchema;
    };
    graphqlRequestInputDescriptor?: GraphQLRequestInputDescriptor;
};
export declare const isModelOperationToolPredicate: (tool: ToolDefinition) => tool is ModelOperationTool;
export declare const isCustomQueryToolPredicate: (tool: ToolDefinition) => tool is CustomQueryTool;
type GraphQLRequestInputDescriptor = {
    selectionSet: string;
    propertyTypes: Record<string, string>;
    queryName: string;
};
export declare const processTools: (toolDefinitions: ToolDefinition[], ctx: TransformerContextProvider) => Tool[] | undefined;
export {};
//# sourceMappingURL=process-tools.d.ts.map