import { TransformerContextProvider } from '@aws-amplify/graphql-transformer-interfaces';
import { BackendOutputEntry, BackendOutputStorageStrategy } from '@aws-amplify/plugin-types';
import * as cdk from 'aws-cdk-lib';
import { ConversationDirectiveConfiguration } from '../conversation-directive-configuration';
export declare class ConversationResolverGenerator {
    private readonly functionNameMap?;
    private readonly outputStorageStrategy?;
    constructor(functionNameMap?: Record<string, cdk.aws_lambda.IFunction> | undefined, outputStorageStrategy?: BackendOutputStorageStrategy<BackendOutputEntry<Record<string, string>>> | undefined);
    generateResolvers(directives: ConversationDirectiveConfiguration[], ctx: TransformerContextProvider): void;
    private generateDataSources;
    private generateResolversForDirective;
    private setupFunctionDataSource;
    private setupExistingFunctionDataSource;
    private setupDefaultConversationHandler;
    private addLambdaDataSource;
    private addSlotsToListMessagesPipeline;
    private addInitSlotToListConversationsPipeline;
    private setupMessageTableIndex;
    private setUpConversationTableIndex;
    private addGlobalSecondaryIndex;
}
//# sourceMappingURL=conversation-resolver-generator.d.ts.map