import { TransformerPluginBase } from '@aws-amplify/graphql-transformer-core';
import { TransformerContextProvider, TransformerSchemaVisitStepContextProvider } from '@aws-amplify/graphql-transformer-interfaces';
import * as lambda from 'aws-cdk-lib/aws-lambda';
import { DirectiveNode, FieldDefinitionNode, InterfaceTypeDefinitionNode, ObjectTypeDefinitionNode, ObjectTypeExtensionNode } from 'graphql';
export declare class FunctionTransformer extends TransformerPluginBase {
    private readonly functionNameMap?;
    private resolverGroups;
    constructor(functionNameMap?: Record<string, lambda.IFunction> | undefined);
    field: (parent: ObjectTypeDefinitionNode | InterfaceTypeDefinitionNode | ObjectTypeExtensionNode, definition: FieldDefinitionNode, directive: DirectiveNode, acc: TransformerSchemaVisitStepContextProvider) => void;
    fieldOfExtendedType: (parent: ObjectTypeExtensionNode, field: FieldDefinitionNode, directive: DirectiveNode, context: TransformerSchemaVisitStepContextProvider) => void;
    generateResolvers: (context: TransformerContextProvider) => void;
}
//# sourceMappingURL=graphql-function-transformer.d.ts.map