import { FunctionRuntimeTemplate, JSRuntimeTemplate, VTLRuntimeTemplate } from '@aws-amplify/graphql-transformer-interfaces';
import { CfnFunctionConfiguration } from 'aws-cdk-lib/aws-appsync';
import { GraphQLApi } from '../graphql-api';
import { Construct } from 'constructs';
export declare const isJsResolverFnRuntime: (runtime?: CfnFunctionConfiguration.AppSyncRuntimeProperty) => boolean;
type RuntimeSpecificFunctionProps = {
    requestMappingTemplate?: string;
    responseMappingTemplate?: string;
    requestMappingTemplateS3Location?: string;
    responseMappingTemplateS3Location?: string;
    runtime?: CfnFunctionConfiguration.AppSyncRuntimeProperty;
    code?: string;
    codeS3Location?: string;
};
export declare const getRuntimeSpecificFunctionProps: (scope: Construct, props: {
    mappingTemplate: FunctionRuntimeTemplate;
    runtime?: CfnFunctionConfiguration.AppSyncRuntimeProperty;
    api: GraphQLApi;
}) => RuntimeSpecificFunctionProps;
export declare const isJsRuntimeTemplate: (mappingTemplate?: Partial<VTLRuntimeTemplate> | JSRuntimeTemplate) => mappingTemplate is JSRuntimeTemplate;
export {};
//# sourceMappingURL=function-runtime.d.ts.map